#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "pssp.h"

/* new version, 10/24/99 PWS, calculates trig functions with lookup table */
float eachatom[NLONG][3];  // I don't know why, but this has to be outside of rfactor()
#define TRIGRES 1000
#define TRO4 250
float costab[TRIGRES];

float rfactor(void){
  /* leaves normalized intensities in intens[].i_icalc, determines r factor */
  int i, j, k, at, isym, iphase;
  float aaa[3];
  struct symelement *sp;
  float sumicalc, phase, real, imag, norm, r, t1, t2;
  float i1, i2;

  sumicalc = 0;

  /* note that the atoms are numbered internally from zero, although externally from one */
  for(at=0; at<nats; at++){
    for(isym=0; isym<nsym; isym++){
      sp = &symelement[isym];
      for(j=0; j<3; j++){
	aaa[j] = sp->s_t[j];
	for(k=0; k<3; k++) aaa[j] += sp->s_m[j][k] * atoms[at].a_xyz[k];
	eachatom[at*nsym + isym][j] = aaa[j];
      }
    }
  }

  for(i=0; i<nintens; i++){
    real = imag =  0;
    for(at=0; at<nats; at++){
      for(isym=0; isym<nsym; isym++){ 
	phase = 0;
	for(j=0; j<3; j++) phase += eachatom[at*nsym + isym][j] * intens[i].i_hkl[j];
	/* real += intens[i].i_fflp[atoms[at].a_atype] * cos(TWOPI * phase) * atoms[at].a_frac; 
	   imag += intens[i].i_fflp[atoms[at].a_atype] * sin(TWOPI * phase) * atoms[at].a_frac;  */

	iphase = (phase * TRIGRES);
	iphase %= TRIGRES;
	real += intens[i].i_fflp[atoms[at].a_atype] * costab[abs(iphase)] * atoms[at].a_frac; 
	if(!centrosym){
	  iphase += TRO4;
	  if(iphase < 0) iphase += TRIGRES;
	  if(iphase >= TRIGRES) iphase -= TRIGRES;
if(iphase < 0 || iphase >= TRIGRES) printf("HELP.  phase = %f, iphase unnorm. to %d\n", phase, iphase);
	  imag += intens[i].i_fflp[atoms[at].a_atype] * costab[iphase] * atoms[at].a_frac; 
	}
      }   
    }
    intens[i].i_icalc = (real*real + imag*imag) * intens[i].i_m;
    sumicalc += intens[i].i_icalc;
  }
  /* printf("sumicalc = %f\n", sumicalc); */
  norm = sumiobs/sumicalc;
  for(i=0; i<nintens; i++) intens[i].i_icalc *= norm;

  r=0;
  for(i=0; i<nintens; i++){
    t1 = intens[i].i_icalc - intens[i].i_iobs;
    r += intens[i].i_cij[0] * t1 * t1;
    for(j=0; j< NOVLP; j++)
      if(i+j < nintens)
      	r += 2 * intens[i].i_cij[j] * (intens[i].i_iobs * intens[i+j].i_iobs + intens[i].i_icalc * intens[i+j].i_icalc
                                  - intens[i].i_iobs * intens[i+j].i_icalc - intens[i].i_icalc * intens[i+j].i_iobs);
  }
  return( r / (sumiobs*sumiobs) );
}

void costabstuff(void){
  int i;
  for(i=0; i<TRIGRES; i++)
    costab[i] = cos(TWOPI * i / TRIGRES);
}







